
## Unsupported search commands 
> To implement support for a command, see [here](/guides/implement-command/) 

#### [FT._LIST](https://redis.io/commands/ft._list/) <small>(not implemented)</small>

Returns a list of all existing indexes

#### [FT.AGGREGATE](https://redis.io/commands/ft.aggregate/) <small>(not implemented)</small>

Run a search query on an index and perform aggregate transformations on the results

#### [FT.ALIASADD](https://redis.io/commands/ft.aliasadd/) <small>(not implemented)</small>

Adds an alias to the index

#### [FT.ALIASDEL](https://redis.io/commands/ft.aliasdel/) <small>(not implemented)</small>

Deletes an alias from the index

#### [FT.ALIASUPDATE](https://redis.io/commands/ft.aliasupdate/) <small>(not implemented)</small>

Adds or updates an alias to the index

#### [FT.ALTER](https://redis.io/commands/ft.alter/) <small>(not implemented)</small>

Adds a new field to the index

#### [FT.CONFIG GET](https://redis.io/commands/ft.config-get/) <small>(not implemented)</small>

Retrieves runtime configuration options

#### [FT.CONFIG HELP](https://redis.io/commands/ft.config-help/) <small>(not implemented)</small>

Help description of runtime configuration options

#### [FT.CONFIG SET](https://redis.io/commands/ft.config-set/) <small>(not implemented)</small>

Sets runtime configuration options

#### [FT.CREATE](https://redis.io/commands/ft.create/) <small>(not implemented)</small>

Creates an index with the given spec

#### [FT.CURSOR DEL](https://redis.io/commands/ft.cursor-del/) <small>(not implemented)</small>

Deletes a cursor

#### [FT.CURSOR READ](https://redis.io/commands/ft.cursor-read/) <small>(not implemented)</small>

Reads from a cursor

#### [FT.DICTADD](https://redis.io/commands/ft.dictadd/) <small>(not implemented)</small>

Adds terms to a dictionary

#### [FT.DICTDEL](https://redis.io/commands/ft.dictdel/) <small>(not implemented)</small>

Deletes terms from a dictionary

#### [FT.DICTDUMP](https://redis.io/commands/ft.dictdump/) <small>(not implemented)</small>

Dumps all terms in the given dictionary

#### [FT.DROPINDEX](https://redis.io/commands/ft.dropindex/) <small>(not implemented)</small>

Deletes the index

#### [FT.EXPLAIN](https://redis.io/commands/ft.explain/) <small>(not implemented)</small>

Returns the execution plan for a complex query

#### [FT.EXPLAINCLI](https://redis.io/commands/ft.explaincli/) <small>(not implemented)</small>

Returns the execution plan for a complex query

#### [FT.INFO](https://redis.io/commands/ft.info/) <small>(not implemented)</small>

Returns information and statistics on the index

#### [FT.PROFILE](https://redis.io/commands/ft.profile/) <small>(not implemented)</small>

Performs a `FT.SEARCH` or `FT.AGGREGATE` command and collects performance information

#### [FT.SEARCH](https://redis.io/commands/ft.search/) <small>(not implemented)</small>

Searches the index with a textual query, returning either documents or just ids

#### [FT.SPELLCHECK](https://redis.io/commands/ft.spellcheck/) <small>(not implemented)</small>

Performs spelling correction on a query, returning suggestions for misspelled terms

#### [FT.SYNDUMP](https://redis.io/commands/ft.syndump/) <small>(not implemented)</small>

Dumps the contents of a synonym group

#### [FT.SYNUPDATE](https://redis.io/commands/ft.synupdate/) <small>(not implemented)</small>

Creates or updates a synonym group with additional terms

#### [FT.TAGVALS](https://redis.io/commands/ft.tagvals/) <small>(not implemented)</small>

Returns the distinct tags indexed in a Tag field


